include	clib.inc
include	dos.inc
include	fblk.inc
include	string.inc
include	filter.inc
include	tdialog.inc
include	time.inc
include	stdio.inc
include	stdlib.inc
include	twindow.inc

	.186

	public	filter
	public	filter_fblk
	public	filter_wblk
	public	filter_edit

	extrn	cp_stdmask: BYTE
	extrn	view_readme: DIST

ID_INCLUDE	EQU	1*16
ID_EXCLUDE	EQU	2*16
ID_MIN_DATE	EQU	3*16
ID_MAX_DATE	EQU	4*16
ID_MIN_SIZE	EQU	5*16
ID_MAX_SIZE	EQU	6*16
ID_RDONLY	EQU	7*16
ID_HIDDEN	EQU	8*16
ID_SYSTEM	EQU	9*16
ID_VOLID	EQU	10*16
ID_SUBDIR	EQU	11*16
ID_ARCH		EQU	12*16
ID_OK		EQU	13*16
ID_CLEAR	EQU	14*16
ID_CANCEL	EQU	15*16

_TEXT	SEGMENT

BINARY	PROC	; CX = flag, AX = date, BX:DX = size
	MOV	SI,WORD PTR filter
	OR	SI,SI
	JZ	BINARY_04
	CMP	AX,[SI.of_min_date]
	JB	BINARY_06
	CMP	[SI.of_max_date],0
	JE	BINARY_00
	CMP	AX,[SI.of_max_date]
	JA	BINARY_06
BINARY_00:
	CMP	BX,WORD PTR [SI.of_min_size+2]
	JB	BINARY_06
	JA	BINARY_01
	MOV	AX,DX
	CMP	AX,WORD PTR [SI.of_min_size]
	JB	BINARY_06
BINARY_01:
	MOV	AX,WORD PTR [SI.of_max_size+2]
	OR	AX,AX
	JZ	BINARY_02
	CMP	BX,AX
	JA	BINARY_06
	JB	BINARY_03
BINARY_02:
	MOV	AX,WORD PTR [SI.of_max_size]
	OR	AX,AX
	JZ	BINARY_03
	CMP	DX,AX
	JA	BINARY_06
BINARY_03:
	MOV	AX,CX
	AND	AX,[SI]
	CMP	AX,CX
	JNE	BINARY_06
BINARY_04:
	XOR	AX,AX
	INC	AX
BINARY_05:
	RET
BINARY_06:
	XOR	AX,AX
	JMP	BINARY_05
BINARY	ENDP

STRING	PROC
	XOR	AX,AX
	CMP	AL,[SI.of_include]
	JE	NCM_01
NCM_00:	PUSH	ES
	PUSH	BX
	PUSH	ES
	PUSH	BX
	PUSH	DS
	ADD	SI,of_include
	PUSH	SI
	CALL	cmpwargs
	POP	CX
	POP	DX
	JZ	NCM_02
	XOR	AX,AX
	SUB	SI,of_include
NCM_01:	CMP	AL,[SI.of_exclude]
	JE	NCM_03
	PUSH	DX
	PUSH	CX
	PUSH	DS
	ADD	SI,of_exclude
	PUSH	SI
	CALL	cmpwargs
	JZ	NCM_03
NCM_02:	XOR	AX,AX
	RET
NCM_03:	XOR	AX,AX
	INC	AX
	RET
STRING	ENDP

IDC_HELP PROC DIST
	MOV	AX,10209
	CALL	view_readme
	RET
IDC_HELP ENDP

IDC_CLEAR PROC DIST
	MOV	DX,DS
	MOV	CX,SI
	LDS	SI,tdialog
	XOR	AX,AX
	MOV	BX,[SI+ID_MIN_DATE+TO_ODATA]
	MOV	[BX],AL
	MOV	BX,[SI+ID_MAX_DATE+TO_ODATA]
	MOV	[BX],AL
	MOV	BX,[SI+ID_MIN_SIZE+TO_ODATA]
	MOV	[BX],AL
	MOV	BX,[SI+ID_MAX_SIZE+TO_ODATA]
	MOV	[BX],AL
	MOV	DS,DX
	MOV	SI,CX
	MOV	AX,WORD PTR filter
	MOV	DX,WORD PTR filter+2
	PUSH	DX
	MOV	BX,AX
	ADD	AX,of_include
	PUSH	AX
	PUSH	DS
	PUSH	OFFSET cp_stdmask
	PUSH	DX
	PUSH	BX
	PUSH	SIZE S_FILT
	CALL	memzero
	CALL	strcpy
	LES	BX,filter
	MOV	ES:[BX.of_flag],-1
	PUSH	WORD PTR tdialog+2
	PUSH	ID_RDONLY
	PUSH	6
	PUSH	_O_FLAGB
	PUSH	-1
	PUSH	-1
	CALL	tdsetbitflag
	MOV	AX,_C_REOPEN
	RET
IDC_CLEAR ENDP

_TEXT	ENDS

PPROC	filter_fblk, fb:DWORD
	PUSH	SI
	LES	BX,fb
	MOV	AX,ES:[BX.fb_date]
	MOV	CX,ES:[BX.fb_flag]
	MOV	DX,WORD PTR ES:[BX.fb_size]
	MOV	BX,WORD PTR ES:[BX.fb_size+2]
	CALL	BINARY
	JZ	FFB_00
	OR	SI,SI
	JZ	FFB_00
	MOV	BX,WORD PTR fb
	ADD	BX,fb_name
	CALL	STRING
FFB_00:	OR	AX,AX
	POP	SI
	RET
PEND	filter_fblk

PPROC	filter_wblk, wf:DWORD
	PUSH	SI
	MLES	BX,wf
	MOV	AX,ES:[BX.wf_datemodified]
	MOV	CX,WORD PTR ES:[BX.wf_attrib]
	MOV	DX,WORD PTR ES:[BX.wf_sizeax]
	MOV	BX,WORD PTR ES:[BX.wf_sizeax+2]
	CALL	BINARY
	JZ	FFW_00
	OR	SI,SI
	JZ	FFW_00
	MOV	BX,WORD PTR wf
	ADD	BX,wf_name
	CALL	STRING
FFW_00:	OR	AX,AX
	POP	SI
	RET
PEND	filter_wblk

PPROC	filter_edit, filt:DWORD, glcmd:DWORD
	PUSH	SI
	PUSH	DI
	XOR	AX,AX
	MOV	WORD PTR filter,AX
	PUSH	DS
	PUSH	WORD PTR IDD_OPERATIONFILTERS
	CALL	rsopen
	JNZ	FEDIT_00
	JMP	FEDIT_08
FEDIT_00:
	PUSH	DX
	PUSH	AX
	PUSH	DS
	PUSH	WORD PTR IDD_OPERATIONFILTERS
	PUSH	DX
	PUSH	AX
	PUSH	DX
	PUSH	AX
	MOV	DI,AX
	MOV	DX,WORD PTR filt+2
	MOV	AX,WORD PTR filt
	ADD	AX,of_include
	MOV	ES:[DI+ID_INCLUDE+TO_ODATA],AX
	MOV	ES:[DI+ID_INCLUDE+TO_SDATA],DX
	ADD	AX,128
	MOV	ES:[DI+ID_EXCLUDE+TO_ODATA],AX
	MOV	ES:[DI+ID_EXCLUDE+TO_SDATA],DX
	MOV	ES:[DI+ID_INCLUDE].to_count,8
	MOV	ES:[DI+ID_EXCLUDE].to_count,8
	LPUSH	CS
	PUSH	OFFSET IDC_HELP
	CALL	thelp_set
	MOV	BX,WORD PTR glcmd
	MOV	ES:[DI+ID_OK+TO_ODATA],BX
	MOV	ES:[DI+ID_OK+TO_SDATA],DS
	MOV	AX,OFFSET IDC_CLEAR
	MOV	ES:[DI+ID_CLEAR+TO_OPROC],AX
	LMOV	ES:[DI+ID_CLEAR+TO_SPROC],CS
FEDIT_01:
	MOV	SI,WORD PTR filt
	MOV	AX,[SI.of_min_date]
	OR	AX,AX
	JZ	FEDIT_02
	PUSH	ES:[DI+ID_MIN_DATE+TO_ODATA]
	PUSH	ES:[DI+ID_MIN_DATE+TO_SDATA]
	PUSH	AX
	CALL	dwtolstr
FEDIT_02:
	MOV	AX,[SI.of_max_date]
	OR	AX,AX
	JZ	FEDIT_03
	PUSH	ES:[DI+ID_MAX_DATE+TO_ODATA]
	PUSH	ES:[DI+ID_MAX_DATE+TO_SDATA]
	PUSH	AX
	CALL	dwtolstr
FEDIT_03:
	MOV	AX,WORD PTR [SI.of_min_size]
	MOV	DX,WORD PTR [SI.of_min_size+2]
	OR	AX,AX
	JZ	FEDIT_04
	PUSH	DX
	PUSH	AX
	MOV	AX,OFFSET format_lu
	MOV	BX,ES:[DI+ID_MIN_SIZE+TO_ODATA]
	MOV	DX,ES:[DI+ID_MIN_SIZE+TO_SDATA]
	CALL	@sprintf
	ADD	SP,4
FEDIT_04:
	MOV	AX,WORD PTR [SI.of_max_size]
	MOV	DX,WORD PTR [SI.of_max_size+2]
	SUB	AX,DX
	ADD	AX,DX
	JZ	FEDIT_05
	PUSH	DX
	PUSH	AX
	MOV	AX,OFFSET format_lu
	MOV	BX,ES:[DI+ID_MAX_SIZE+TO_ODATA]
	MOV	DX,ES:[DI+ID_MAX_SIZE+TO_SDATA]
	CALL	@sprintf
	ADD	SP,4
FEDIT_05:
	PUSH	ES
	PUSH	ID_RDONLY+4
	PUSH	6
	PUSH	_O_FLAGB
	MOV	AX,[SI.of_flag]
	PUSH	AX
	PUSH	AX
	CALL	tdsetbitflag
	CALL	tdinit
	MOV32	filter,filt
	CALL	rsevent
	CALL	twclose
	OR	DX,DX
	JNZ	FEDIT_09
	XOR	AX,AX
	MOV	WORD PTR filter,AX
	MOV	WORD PTR filter+2,AX
FEDIT_06:
	MOV	AX,_C_NORMAL
FEDIT_07:
	CALL	thelp_pop
FEDIT_08:
	POP	DI
	POP	SI
	RET
FEDIT_09:
	MOV	AX,ES
	PUSH	AX
	PUSH	ES:[DI+ID_MIN_DATE+TO_ODATA]
	PUSH	AX
	PUSH	ES:[DI+ID_MAX_DATE+TO_ODATA]
	PUSH	AX
	PUSH	ES:[DI+ID_MIN_SIZE+TO_ODATA]
	PUSH	AX
	PUSH	ES:[DI+ID_MAX_SIZE+TO_ODATA]
	PUSH	AX
	PUSH	ID_RDONLY+4
	PUSH	6
	PUSH	_O_FLAGB
	CALL	tdgetbitflag
	OR	AX,0FFC0h
	MOV	[SI.of_flag],AX
	CALL	strtol
	STO32	[SI.of_max_size]
	CALL	strtol
	STO32	[SI.of_min_size]
	CALL	strtodw
	MOV	[SI.of_max_date],AX
	CALL	strtodw
	MOV	[SI.of_min_date],AX
	JMP	FEDIT_06
PEND	filter_edit

_DATA	SEGMENT

filter		DD	00000000h
format_lu	DB	'%lu',0

;******** Resource begin OPERATIONFILTERS *
;	{ 0x00DC,  15,  12, {10, 4,61,16} },
;	{ 0x0084,   0, 'I', {12, 3,45, 1} },
;	{ 0x0084,   0, 'E', {12, 4,45, 1} },
;	{ 0x0084,   2, 'F', {12, 7,16, 1} },
;	{ 0x0084,   2, 'B', {12, 8,16, 1} },
;	{ 0x0084,   2, 'V', {41, 7,16, 1} },
;	{ 0x0084,   2, 'W', {41, 8,16, 1} },
;	{ 0x0022,   0, 'R', { 4,11,13, 1} },
;	{ 0x0022,   0, 'H', { 4,12,10, 1} },
;	{ 0x0022,   0, 'Y', {22,11,10, 1} },
;	{ 0x8002,   0,   0, {22,12,10, 1} },
;	{ 0x8022,   0,   0, {40,11,16, 1} },
;	{ 0x0022,   0, 'A', {40,12,11, 1} },
;	{ 0x1000,   0, 'O', { 3,14, 6, 1} },
;	{ 0x4000,   0, 'L', {13,14, 9, 1} },
;	{ 0x0200,   0, 'C', {47,14,10, 1} },
;******** Resource data  *******************
OPERATIONFILTERS_RC LABEL WORD
	DW	0097Bh	; Alloc size
	DW	000DCh,00C0Fh,0040Ah,0103Dh,00084h,04900h,0030Ch,0012Dh
	DW	00084h,04500h,0040Ch,0012Dh,00084h,04602h,0070Ch,00110h
	DW	00084h,04202h,0080Ch,00110h,00084h,05602h,00729h,00110h
	DW	00084h,05702h,00829h,00110h,00022h,05200h,00B04h,0010Dh
	DW	00022h,04800h,00C04h,0010Ah,00022h,05900h,00B16h,0010Ah
	DW	08002h,00000h,00C16h,0010Ah,08022h,00000h,00B28h,00110h
	DW	00022h,04100h,00C28h,0010Bh,01000h,04F00h,00E03h,00106h
	DW	04000h,04C00h,00E0Dh,00109h,00200h,04300h,00E2Fh,0010Ah
	DW	03DF0h,0F050h,02A7Eh,0F03Fh,02A07h,02DF0h,0F007h,02A08h
	DW	0F03Fh,02A07h,02DF0h,0F007h,02A83h,0F02Eh,02A06h,010F0h
	DW	0F007h,02A08h,0F02Eh,02A04h,010F0h,0F007h,02A08h,0F02Eh
	DW	02A07h,010F0h,0F007h,02A09h,0F02Eh,02A03h,010F0h,0F007h
	DW	02A86h,0F02Eh,02A12h,0F02Eh,02A0Ch,00DF0h,0F028h,02A10h
	DW	0F02Eh,02A0Dh,009F0h,0F028h,02A0Dh,0F02Eh,02A50h,05050h
	DW	0F05Ch,05003h,0F020h,02A03h,003F0h,05C50h,005F0h,02050h
	DW	00BF0h,0202Ah,00CF0h,0502Ah,05C50h,007F0h,02050h,007F0h
	DW	0F02Ah,02006h,004F0h,0F02Ah,02009h,004F0h,0F02Ah,02008h
	DW	00DF0h,0F02Ah,0200Ah,003F0h,0F02Ah,02016h,0704Fh,07265h
	DW	07461h,06F69h,0206Eh,06946h,0746Ch,07265h,056F0h,0DA20h
	DW	04620h,06C69h,02065h,0616Eh,0656Dh,0C420h,020C4h,03346h
	DW	0F020h,0C426h,0F0BFh,02004h,020B3h,06E49h,06C63h,06475h
	DW	0F065h,0202Fh,0F0B3h,02004h,020B3h,07845h,06C63h,06475h
	DW	0F065h,0202Fh,0F0B3h,02004h,0F0C0h,0C437h,0F0D9h,02004h
	DW	020DAh,06946h,0656Ch,06420h,07461h,02065h,0C4C4h,04620h
	DW	02034h,009F0h,0BFC4h,0DA20h,04620h,06C69h,02065h,06973h
	DW	0657Ah,0F020h,0C40Fh,0F0BFh,02004h,020B3h,06641h,06574h
	DW	0F072h,02014h,020B3h,020B3h,06241h,0766Fh,0F065h,02014h
	DW	0F0B3h,02004h,020B3h,06542h,06F66h,06572h,013F0h,0B320h
	DW	0B320h,04220h,06C65h,0776Fh,014F0h,0B320h,004F0h,0C020h
	DW	01AF0h,0D9C4h,0C020h,01AF0h,0D9C4h,004F0h,0DA20h,04120h
	DW	07474h,06972h,07562h,06574h,06620h,06C69h,06574h,07372h
	DW	0F020h,0C424h,0F0BFh,02004h,020B3h,0785Bh,0205Dh,06552h
	DW	06461h,04F20h,06C6Eh,0F079h,02005h,0785Bh,0205Dh,07953h
	DW	07473h,06D65h,008F0h,05B20h,05D78h,04420h,07269h,06365h
	DW	06F74h,07972h,005F0h,0B320h,004F0h,0B320h,05B20h,05D78h
	DW	04820h,06469h,06564h,0F06Eh,02008h,0205Bh,0205Dh,06F56h
	DW	0696Ch,0F064h,02009h,0785Bh,0205Dh,07241h,06863h,07669h
	DW	0F065h,02007h,0F0B3h,02004h,0F0C0h,0C437h,0F0D9h,02007h
	DW	06B4Fh,02020h,0F0DCh,02005h,06C43h,06165h,02072h,0DC20h
	DW	01AF0h,04320h,06E61h,06563h,0206Ch,0DC20h,007F0h,0F020h
	DW	0DF06h,004F0h,0F020h,0DF09h,019F0h,0F020h,0DF0Ah,003F0h
	DW	02A20h
;	660 byte
IDD_OPERATIONFILTERS DD DGROUP:OPERATIONFILTERS_RC

;	public	IDD_OPERATIONFILTERS

;******** Resource end   OPERATIONFILTERS *

_DATA	ENDS

	END
